<template>
    <div class="ProductQuery">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">产品追溯</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getProductQueryList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTable"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="productCode" label="产品编码"></el-table-column>
                    <el-table-column prop="productName" label="产品名称"></el-table-column>
                    <el-table-column prop="saleTime" label="出售时间"></el-table-column>
                    <el-table-column prop="partitionTime" label="分割时间"></el-table-column>
                    <el-table-column prop="cuttingTime" label="宰割时间"></el-table-column>
                    <el-table-column prop="placeOrigin" label="来源地"></el-table-column>
                    <el-table-column prop="quarantineTime" label="检疫时间"></el-table-column>
                    <el-table-column prop="quarantineForm" label="检疫单"></el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增/编辑" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form ref="addProductQuery" :model="formData" :rules="rules" label-width="140px">
                        <el-form-item label="产品编码">
                            <el-input v-model="formData.productCode"></el-input>
                        </el-form-item>

                        <el-form-item label="产品名称">
                            <el-input v-model="formData.productName"></el-input>
                        </el-form-item>

                        <el-form-item label="出售时间">
                            <el-date-picker
                                v-model="formData.saleTime"
                                type="date"
                                value-format="yyyy-MM-dd"
                                placeholder="选择日期"
                            ></el-date-picker>
                        </el-form-item>

                         <el-form-item label="分割时间">
                            <el-date-picker
                                v-model="formData.partitionTime"
                                type="date"
                                value-format="yyyy-MM-dd"
                                placeholder="选择日期"
                            ></el-date-picker>
                        </el-form-item>

                         <el-form-item label="宰割时间">
                            <el-date-picker
                                v-model="formData.cuttingTime"
                                type="date"
                                value-format="yyyy-MM-dd"
                                placeholder="选择日期"
                            ></el-date-picker>
                        </el-form-item>

                        <el-form-item label="来源地">
                            <el-input v-model="formData.placeOrigin"></el-input>
                        </el-form-item>

                         <el-form-item label="检疫时间">
                            <el-date-picker
                                v-model="formData.quarantineTime"
                                type="date"
                                value-format="yyyy-MM-dd"
                                placeholder="选择日期"
                            ></el-date-picker>
                        </el-form-item>

                        <el-form-item label="检疫单">
                            <el-input v-model="formData.quarantineForm"></el-input>
                        </el-form-item>

                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addProductQuery')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqProductQueryList,
    reqAddProductQuery,
    reqUpdateProductQuery,
    reqDelProductQuery
} from "@/api/storeTransportation.js";

const pageSize = 10;
const rules = {};

export default {
    name: "ProductQuery",
    data() {
        return {
            search: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                productCode: "156546",
                productName: "产品名称",
                saleTime: this.$moment().format("YYYY-MM-DD"),
                partitionTime: this.$moment().format("YYYY-MM-DD"),
                cuttingTime: this.$moment().format("YYYY-MM-DD"),
                placeOrigin: "哈斯牧场",
                quarantineTime: this.$moment().format("YYYY-MM-DD"),
                quarantineForm: "检疫单"
            },
            isAdd: false,
            rules
        };
    },
    created() {
        // 出仓管理列表
        this.getProductQueryList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddProductQuery(this.formData)
                            .then(res => {
                                // 出仓管理列表
                                this.getProductQueryList();
                                this.$message.success("添加成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdateProductQuery(this.formData)
                            .then(res => {
                                // 出仓管理列表
                                this.getProductQueryList();
                                this.$message.success("编辑成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 出仓管理列表
        getProductQueryList() {
            reqProductQueryList({
                searchStr: this.search,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            this.isAdd = true;
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false;
        },
        del(row) {
            reqDelProductQuery(row.id)
                .then(res => {
                    console.log(res);
                    // 出仓管理列表
                    this.getProductQueryList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.page = p;
            // 出仓管理列表
            this.getProductQueryList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>